package lcsb.mapviewer.services.search.layout;

import org.apache.log4j.Logger;

import com.google.gson.Gson;

import lcsb.mapviewer.common.Pair;
import lcsb.mapviewer.model.map.layout.ColorSchema;
import lcsb.mapviewer.model.map.reaction.Reaction;
import lcsb.mapviewer.services.search.ElementViewFactory;

/**
 * Factory class for {@link LightLayoutReactionView} class.
 * 
 * @author Piotr Gawron
 * 
 */
public class FullLayoutReactionViewFactory extends ElementViewFactory<Pair<Reaction, ColorSchema>, FullLayoutReactionView> {
	/**
	 * Default class logger.
	 */
	@SuppressWarnings("unused")
	private static Logger logger = Logger.getLogger(FullLayoutReactionViewFactory.class);

	@Override
	public FullLayoutReactionView create(Pair<Reaction, ColorSchema> pair) {
		FullLayoutReactionView result = new FullLayoutReactionView(pair.getLeft());
		result.setColor(pair.getRight().getColor());
		result.setValue(pair.getRight().getValue());
		result.setWidth(pair.getRight().getLineWidth());
		result.setReverse(pair.getRight().getReverseReaction());
		return result;
	}

	@Override
	public String createGson(FullLayoutReactionView object) {
		return new Gson().toJson(object);
	}
}
