package lcsb.mapviewer.services.search.layout;

import org.apache.log4j.Logger;

import com.google.gson.Gson;

import lcsb.mapviewer.common.Pair;
import lcsb.mapviewer.model.map.layout.ColorSchema;
import lcsb.mapviewer.model.map.reaction.Reaction;
import lcsb.mapviewer.services.search.ElementViewFactory;

/**
 * Factory class for {@link LightLayoutReactionView} class.
 * 
 * @author Piotr Gawron
 * 
 */
public class LightLayoutReactionViewFactory extends ElementViewFactory<Pair<Reaction, ColorSchema>, LightLayoutReactionView> {
	/**
	 * Default class logger.
	 */
	@SuppressWarnings("unused")
	private static Logger logger = Logger.getLogger(LightLayoutReactionViewFactory.class);

	@Override
	public LightLayoutReactionView create(Pair<Reaction, ColorSchema> pair) {
		LightLayoutReactionView result = new LightLayoutReactionView(pair.getLeft());
		result.setColor(pair.getRight().getColor());
		result.setValue(pair.getRight().getValue());
		result.setWidth(pair.getRight().getLineWidth());
		result.setReverse(pair.getRight().getReverseReaction());
		return result;
	}

	@Override
	public String createGson(LightLayoutReactionView object) {
		return new Gson().toJson(object);
	}
}
