package lcsb.mapviewer.services.utils.gmap;

import org.primefaces.model.DefaultTreeNode;

import com.google.gson.ExclusionStrategy;
import com.google.gson.FieldAttributes;

/**
 * This object imlements an exclusion strategy that forbides to serialize
 * "Chebi Tree" like objects. This kind of objects are represented as
 * {@link DefaultTreeNode} class.
 * 
 * @author Piotr Gawron
 * 
 */
public class GsonExclusionChebiTreeStrategy implements ExclusionStrategy {

	@Override
	public boolean shouldSkipClass(Class<?> arg0) {
		if (DefaultTreeNode.class.isAssignableFrom(arg0)) {
			return true;
		}
		return false;
	}

	@Override
	public boolean shouldSkipField(FieldAttributes fa) {
		return false;

	}

}
