package lcsb.mapviewer.services.view;

import java.io.Serializable;

/**
 * View representation.
 * 
 * @author Ayan Rota
 * 
 */
public class AbstractTargetView implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Icon associated with the target.
	 */
	private String					icon;
	
	/**
	 * Type of the target. Possible values are set in
	 */
	private String					type;
	
	/**
	 * Is the target selectable by client.
	 */
	private Boolean					selectable	= false;
	
	/**
	 * Is the target selected by client.
	 */
	private Boolean					selected		= false;
	
	/**
	 * Is the target visiblke to the client.
	 */
	private Boolean					visible			= false;
	
	/**
	 * defualt constructor.
	 */
	public AbstractTargetView() {
		super();
	}


	/**
	 * @return the icon
	 * @see #icon
	 */
	public String getIcon() {
		return icon;
	}

	/**
	 * @param icon
	 *          the icon to set
	 * @see #icon
	 */
	public void setIcon(String icon) {
		this.icon = icon;
	}

	/**
	 * @return the selectable
	 * @see #selectable
	 */
	public Boolean getSelectable() {
		return selectable;
	}

	/**
	 * @param selectable
	 *          the selectable to set
	 * @see #selectable
	 */
	public void setSelectable(Boolean selectable) {
		this.selectable = selectable;
	}

	/**
	 * @return the selected
	 * @see #selected
	 */
	public Boolean getSelected() {
		return selected;
	}

	/**
	 * @param selected
	 *          the selected to set
	 * @see #selected
	 */
	public void setSelected(Boolean selected) {
		this.selected = selected;
	}

	/**
	 * @return the visible
	 * @see #visible
	 */
	public Boolean getVisible() {
		return visible;
	}

	/**
	 * @param visible
	 *          the visible to set
	 * @see #visible
	 */
	public void setVisible(Boolean visible) {
		this.visible = visible;
	}
	
	/**
	 * @return the type
	 * @see #type
	 */
	public String getType() {
		return type;
	}

	/**
	 * @param type
	 *          the type to set
	 * @see #type
	 */
	public void setType(String type) {
		this.type = type;
	}

}
